import { Response } from "./response";
import { CreateContextFunction, AliyunHttpContext } from "./types";
import { Request } from "./request";
export declare class Context {
    req: Request;
    res: Response;
    private readonly originalCtx;
    constructor(req: Request, res: Response, originalCtx: AliyunHttpContext);
    readonly credentials: import("./types").AliyunHttpContextCredentials;
    readonly service: import("./types").AliyunHttpContextService;
    readonly query: {
        [key: string]: string | any[];
    };
    readonly requestId: string;
    readonly accountId: string;
    readonly function: import("./types").AliyunHttpContextFunction;
    readonly region: string;
    setHeader(field: string, value: string): void;
    removeHeader(field: string): void;
    readonly header: {
        [key: string]: any;
    };
    readonly headers: {
        [key: string]: any;
    };
    status: number;
    body: any;
    finish(): void;
    redirect(newUrl: string): void;
}
export declare const createContext: CreateContextFunction;
