/// <reference types="node" />
import MockReq from "mock-req";
export declare const couldHaveBody: (method: string) => boolean;
export interface ITestReq {
    method?: string;
    query?: {
        [key: string]: any;
    };
    body?: any;
    headers?: {
        [key: string]: string;
    };
}
export declare const mockRequest: (req?: ITestReq) => MockReq & {
    queries: {
        [key: string]: any;
    };
    clientIp: string;
    path: string;
};
export declare const mockResponse: () => {
    setStatusCode: (statusCode: number) => void;
    setHeader: (headerKey: string, headerValue: string) => void;
    deleteHeader: (headerKey: string) => void;
    send: (body: string | ReadableStream<any> | Buffer) => void;
};
export declare const mockContext: () => {
    requestId: string;
    credentials: {
        accessKeyId: string;
        accessKeySecret: string;
        securityToken: string;
    };
    function: {
        name: string;
        handler: string;
        memory: number;
        timeout: number;
        initializer: string;
        initializationTimeout: number;
    };
    service: {
        name: string;
        logProject: string;
        logStore: string;
        qualifier: string;
        versionId: string;
    };
    region: string;
    accountId: string;
};
