"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const p_timeout_1 = __importDefault(require("p-timeout"));
const context_1 = require("./context");
exports.wrapper = (handler, options) => {
    options = options || {};
    const onError = options.onError ||
        ((e, ctx) => {
            ctx.body = { errMessage: e.message };
        });
    return (request, response, context) => __awaiter(this, void 0, void 0, function* () {
        const run = () => __awaiter(this, void 0, void 0, function* () {
            const ctx = yield context_1.createContext(request, response, context);
            try {
                yield handler(ctx);
                ctx.status = ctx.status || 200;
            }
            catch (e) {
                ctx.status = ctx.status >= 400 ? ctx.status : 500;
                onError(e, ctx);
            }
            finally {
                ctx.finish();
            }
            return ctx;
        });
        return options.timeout ? p_timeout_1.default(run(), options.timeout) : run();
    });
};
//# sourceMappingURL=wrapper.js.map